#!/bin/sh
# <BEGIN COPYRIGHT>
# This file is part of the "Bad Penguin" GNU/Linux distribution
# Copyright (C) 1997-98-99 by Antonio GALLO
# Home Page at ......: http://www.badpenguin.org
# Home Page at ......: http://www.linux.it/~agx/
# e-mail contact ....: mailto:agx@linux.it	mailto:agx@geocities.com
# This program is distributed under the GNU General Public License
# You are not allowed to remove the copyright notice
# <END COPYRIGHT>

# 1.0.4 by agx@linux.it 
# 1.1.0 by agx@linux.it : split in two files
# 1.1.1 by agx@linux.it : sync with SUSE

# ############################################################
echoc CYAN "Filesystem Hierarchy Standard - Version 2.0"
# ############################################################

DEBUG=0
if [ -f ./fhs20.sh ]; then
  echoc GREEN "You are running me from the local directory."
  echoc GREEN "I need to switch to the upper directory."
  cd ..
  sleep 2
  DEBUG=1
fi

echo "Creating directory structures"
umask 022

# -----------------------------------------------------

echo -n "root, "
mkdir -p bin
mkdir -p boot
mkdir -p cdrom
mkdir -p dev
mkdir -p etc
mkdir -p floppy
mkdir -p home
mkdir -p lib
mkdir -p mnt
mkdir -p proc
mkdir -p root
mkdir -p sbin
mkdir -p tmp
mkdir -p usr
mkdir -p var

# -----------------------------------------------------

echo -n "etc, "
rm -f etc/X11
ln -sf /usr/X11R6/lib/X11 	etc/X11
mkdir -p etc/init.d
mkdir -p etc/skel
mkdir -p etc/default
mkdir -p etc/sysconfig
mkdir -p etc/sysconfig/DEFAULT

# -----------------------------------------------------

echo -n "lib, "
mkdir -p lib/modules

# -----------------------------------------------------

echo -n "opt, "
mkdir -p opt

# -----------------------------------------------------

echo -n "usr, "
mkdir  -p usr/bin
mkdir  -p usr/dict
mkdir  -p usr/doc
mkdir  -p usr/games
mkdir  -p usr/include
mkdir  -p usr/info
mkdir  -p usr/lib
rm -f     usr/man
ln -sf   /usr/share/man	usr/man
mkdir  -p usr/sbin
mkdir  -p usr/share
mkdir  -p usr/src

# -----------------------------------------------------

echo -n "usr/X11R6, "
mkdir -p usr/X11R6
mkdir -p usr/X11R6/bin
rm  -f   usr/bin/X11
ln  -sf /usr/X11R6/bin			usr/bin/X11
mkdir -p usr/X11R6/doc
mkdir -p usr/X11R6/include
mkdir -p usr/X11R6/include/X11
rm  -f   usr/include/X11
ln  -sf /usr/X11R6/include/X11		usr/include/X11
mkdir -p usr/X11R6/lib
mkdir -p usr/X11R6/lib/X11
rm  -f   usr/lib/X11
ln  -sf /usr/X11R6/lib/X11		usr/lib/X11
mkdir -p usr/X11R6/man

# -----------------------------------------------------

echo -n "usr/lib, "
mkdir  -p usr/lib/games
rm    -f  usr/lib/terminfo	usr/lib/zoneinfo
ln   -sf /usr/share/terminfo	usr/lib/terminfo
ln   -sf /usr/share/zoneinfo	usr/lib/zoneinfo

# -----------------------------------------------------

echo  -n "usr/local, "
mkdir  -p usr/local
mkdir  -p usr/local/bin
mkdir  -p usr/local/doc
mkdir  -p usr/local/include
mkdir  -p usr/local/lib
mkdir  -p usr/local/info
mkdir  -p usr/local/man
mkdir  -p usr/local/sbin
mkdir  -p usr/local/share
mkdir  -p usr/local/src

# -----------------------------------------------------

echo -n "usr/share, "
mkdir -p usr/share
mkdir -p usr/share/doc
mkdir -p usr/share/info
mkdir -p usr/share/locale
mkdir -p usr/share/man/
mkdir -p usr/share/nls
mkdir -p usr/share/misc
mkdir -p usr/share/terminfo
mkdir -p usr/share/zoneinfo 

# -----------------------------------------------------

echo -n "var, "
mkdir -p var/account
rm  -f   var/adm
ln  -sf /var/log    var/adm
mkdir -p var/backups
mkdir -p var/lib
mkdir -p var/local
mkdir -p var/lock
mkdir -p var/lock/subsys
mkdir -p var/log 
mkdir -p var/run
mkdir -p var/spool
rm   -f   var/tmp
ln   -sf /tmp			var/tmp

# -----------------------------------------------------

echo -n "var/lib, "

mkdir -p var/lib/dpkg
chmod 0755 var/lib/dpkg
chown root.root var/lib/dpkg
if [ ! -f var/lib/dpkg/status ]; then
  > var/lib/dpkg/status
  chmod 644 var/lib/dpkg/status
  chown root.root var/lib/dpkg/status
fi

# -----------------------------------------------------

echo -n "var/log, "
[ ! -f var/log/auth.log ] && > var/log/auth.log
[ ! -f var/log/lastlog ]  && > var/log/lastlog
[ ! -f var/log/messages ] && > var/log/messages
# AGX Extension
[ ! -f var/log/utmp.history ] && > var/log/utmp.history
[ ! -f var/log/wtmp.history ] && > var/log/wtmp.history

# Slackware package management
mkdir -p var/log/packages
mkdir -p var/log/scripts
mkdir -p var/log/setup
mkdir -p var/log/setup/tmp


# -----------------------------------------------------

echo -n "var/spool, "
rm  -f   var/spool/lock
ln  -sf /var/lock   var/spool/lock
mkdir -p var/spool/mail

# -----------------------------------------------------

echo -n "utmp/wtmp, "
[ ! -f var/log/btmp ]     && > var/log/btmp
[ ! -f var/log/wtmp ]     && > var/log/wtmp
rm -f   var/log/utmp
ln -sf /var/run/utmp	  var/log/utmp
chown root.root 	var/run/utmp 	var/log/wtmp
chmod 644		var/run/utmp 	var/log/wtmp

# -----------------------------------------------------

echo
echo
echo "You system is now FSST 2.0 compliant."
echo

[ $DEBUG -eq 1 ] && echoc GREEN "Pres ENTER to continue ..." ; read x
exit
